<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AbstractExecuteInJobHandler xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/AbstractExecuteInJobHandler.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2016 Cedric Dumoulin and others.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *   Cedric Dumoulin - Initial API and implementation</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *   </em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.handlers;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.AbstractHandler;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.ExecutionEvent;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.ExecutionException;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.IHandler;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.expressions.IEvaluationContext;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IProject;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.CoreException;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IProgressMonitor;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IStatus;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.Status;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.jobs.Job;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.transaction.RecordingCommand;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.transaction.TransactionalEditingDomain;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.IJavaElement;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.IJavaProject;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.JavaCore;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.dialogs.ErrorDialog;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ISelection;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.TreeSelection;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.Messages;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.exception.JavaReverseException;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.Activator;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.sasheditor.editor.ISashWindowsContainer;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.services.ServiceException;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.services.ServicesRegistry;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.services.spi.IContextualServiceRegistryTracker;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.utils.ServiceUtils;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.ui.util.ServiceUtilsForHandlers;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.model.UmlModel;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Shell;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.IEditorPart;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.ISources;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.IWorkbenchPage;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.PlatformUI;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.handlers.HandlerUtil;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment"> * A base class to implemnet ui {@link IHandler} that should run in a Job and in a transactional command.</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_javadoccomment"> * &lt;br&gt;</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_javadoccomment"> * This class must be subclassed, and the following method should be implemented :</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <em class="jxr_javadoccomment"> * &lt;ul&gt;</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment"> * &lt;li&gt;{@link #getJobName()&lt;/li&gt;</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment"> * &lt;li&gt;{@link #doPrepareExecute(ExecutionEvent)}&lt;/li&gt;</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment"> * &lt;li&gt;{@link #doExecuteTransactionInJob(IProgressMonitor)}&lt;/li&gt;</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment"> * &lt;/ul&gt;</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment"> * This method are called in the previous order.</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_javadoccomment"> * &lt;br&gt;</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment"> * This class also provides miscellaneous methods.</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment"> * @author cedric dumoulin</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/AbstractExecuteInJobHandler.html">AbstractExecuteInJobHandler</a> <strong class="jxr_keyword">extends</strong> AbstractHandler {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String EDITOR_ID = Activator.PLUGIN_ID;
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  <em class="jxr_javadoccomment">	 * Event provided to the execute method. The event is stored when the execute() method start.</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  <em class="jxr_javadoccomment">	 * Other method can then use this event.</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  	<strong class="jxr_keyword">protected</strong> ExecutionEvent event;
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  	<strong class="jxr_keyword">protected</strong> ServicesRegistry registry;
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  	<strong class="jxr_keyword">protected</strong> TransactionalEditingDomain domain;
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  <em class="jxr_javadoccomment">	 * Constructor.</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/AbstractExecuteInJobHandler.html">AbstractExecuteInJobHandler</a>() {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  		<strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  	}
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  <em class="jxr_javadoccomment">	 * Method called when button is pressed.</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  	@Override
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  	<strong class="jxr_keyword">public</strong> Object execute(ExecutionEvent event) <strong class="jxr_keyword">throws</strong> ExecutionException {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		<em class="jxr_comment">// Store the event in order to be able to use it from utility methods.</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		<strong class="jxr_keyword">this</strong>.event = event;
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		<em class="jxr_comment">// Try to connect to a valid Papyrus ServicesRegistry</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 			registry = lookupServiceRegistry(event);
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 			domain = getEditingDomain();
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		} <strong class="jxr_keyword">catch</strong> (ServiceException e) {
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 			<em class="jxr_comment">// No uml resource available. User must open a model. We open an error dialog with an explicit message to advice user.</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 			Shell shell = getShell();
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			Status errorStatus = <strong class="jxr_keyword">new</strong> Status(IStatus.ERROR, Activator.PLUGIN_ID, Messages.ReverseCodeHandler_NoPapyrusEditor_Title);
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			ErrorDialog.openError(shell, <span class="jxr_string">""</span>, Messages.ReverseCodeHandler_NoPapyrusEditor_Message, errorStatus);
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 	
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 			<em class="jxr_comment">// Stop the handler execution.</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 	
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		<strong class="jxr_keyword">boolean</strong> isStatusOk = doPrepareExecute(event);
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		<strong class="jxr_keyword">if</strong>( !isStatusOk) {
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		}
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		<em class="jxr_comment">// Create Job</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		Job job = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/AbstractExecuteInJobHandler.html">JobForHandler</a>(getJobName(), domain);
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		<em class="jxr_comment">// Execute Job</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		job.setUser(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		job.schedule();
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 	
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 	}
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> <em class="jxr_javadoccomment">	 * Return a name that will be used for the created Job.</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L133" href="#L133">133</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 	<strong class="jxr_keyword">abstract</strong> String getJobName();
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 	
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L137" href="#L137">137</a> <em class="jxr_javadoccomment">	 * This method is called outside the Job and outside the transaction. It is called first.</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> <em class="jxr_javadoccomment">	 * This method can be used to prepare the execution, check if the handler can be executed, collect data ...</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_javadoccomment">	 * @param event</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_javadoccomment">	 * @return True if the execution should continue, false if the execution should stop.</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">boolean</strong> doPrepareExecute(ExecutionEvent event);
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_javadoccomment">	 * This method is run inside a Job and in a Transaction.</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> <em class="jxr_javadoccomment">	 * Papyrus models can be modified inside this method.</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> <em class="jxr_javadoccomment">	 * @param monitor</em>
<a class="jxr_linenumber" name="L151" href="#L151">151</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">void</strong> doExecuteTransactionInJob(IProgressMonitor monitor);
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> <em class="jxr_javadoccomment">	 * Get the active shell from the event, or from the active page if event is null.</em>
<a class="jxr_linenumber" name="L156" href="#L156">156</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> <em class="jxr_javadoccomment">	 * @param event</em>
<a class="jxr_linenumber" name="L158" href="#L158">158</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L159" href="#L159">159</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 	<strong class="jxr_keyword">protected</strong> Shell getShell() {
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 		
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 		<strong class="jxr_keyword">if</strong>(event != <strong class="jxr_keyword">null</strong> ) {
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 			<strong class="jxr_keyword">return</strong> HandlerUtil.getActiveShell(event);
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 		}
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 			<strong class="jxr_keyword">return</strong> PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart().getSite().getShell();
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 	
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 		}
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 	}
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> <em class="jxr_javadoccomment">	 * @param event</em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 	<strong class="jxr_keyword">protected</strong> ServicesRegistry lookupServiceRegistry(ExecutionEvent event) <strong class="jxr_keyword">throws</strong> ServiceException {
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 		
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 		ServicesRegistry registry;
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 		
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			<em class="jxr_comment">// This utility accept null event.</em>
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 			registry = ServiceUtilsForHandlers.getInstance().getServiceRegistry(event);
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 		} <strong class="jxr_keyword">catch</strong> (ServiceException e1) {
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 			registry = getContextualServiceRegistry();
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 		}
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 		<strong class="jxr_keyword">return</strong> registry;
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 	}
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L189" href="#L189">189</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> <em class="jxr_javadoccomment">	 * @return the name of the selected project into explorer</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 	<strong class="jxr_keyword">protected</strong> String getSelectedProjectName() <strong class="jxr_keyword">throws</strong> JavaReverseException {
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 		
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 		<em class="jxr_comment">// Lookup selection</em>
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 		ISelection selection = getCurrentSelection();
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 	
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		<em class="jxr_comment">// Lookup the java compilation unit.</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 		TreeSelection treeSelection = (TreeSelection)selection;
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 		IJavaProject javaProject = getNodeEnclosingIJavaProject(treeSelection.getFirstElement());
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 		String name = javaProject.getAncestor(IJavaProject.JAVA_PROJECT).getElementName();
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 		<strong class="jxr_keyword">return</strong> name;
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 	}
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> <em class="jxr_javadoccomment">	 * Get the {@link IJavaProject} containing the provided node. Node should be an node selected in Package/Project Explorer.</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> <em class="jxr_javadoccomment">	 * @param node The node for which the enclosing {@link IJavaProject} is looked. </em>
<a class="jxr_linenumber" name="L208" href="#L208">208</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> <em class="jxr_javadoccomment">	 * @throws CoreException </em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 	<strong class="jxr_keyword">protected</strong> IJavaProject getNodeEnclosingIJavaProject(Object node) <strong class="jxr_keyword">throws</strong> JavaReverseException {
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 		
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 		<strong class="jxr_keyword">if</strong>( node instanceof IJavaElement ) {
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 			
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 			<strong class="jxr_keyword">return</strong> (IJavaProject)((IJavaElement)node).getAncestor(IJavaProject.JAVA_PROJECT);
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 		}
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 		<strong class="jxr_keyword">if</strong>( node instanceof IProject ) {
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 			<em class="jxr_comment">// Try to get the Java nature</em>
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 			IProject project = (IProject)node;
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 				<strong class="jxr_keyword">if</strong> (project.hasNature(JavaCore.NATURE_ID)) {
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 					IJavaProject javaProject = (IJavaProject)project.getNature(JavaCore.NATURE_ID);
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 				<strong class="jxr_keyword">return</strong> javaProject;
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 				}
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 			} <strong class="jxr_keyword">catch</strong> (CoreException e) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/exception/JavaReverseException.html">JavaReverseException</a>(<span class="jxr_string">"Can't find enclosing Project for node '"</span> + node +<span class="jxr_string">"'"</span>, e);
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 			}
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 		}
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 		
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 		<em class="jxr_comment">// Not found</em>
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 		<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/exception/JavaReverseException.html">JavaReverseException</a>(<span class="jxr_string">"Can't find enclosing Project for node '"</span> + node +<span class="jxr_string">"'"</span>);
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 	}
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L235" href="#L235">235</a> <em class="jxr_javadoccomment">	 * Get the current selection.</em>
<a class="jxr_linenumber" name="L236" href="#L236">236</a> <em class="jxr_javadoccomment">	 * First, try with ISources.ACTIVE_CURRENT_SELECTION_NAME.</em>
<a class="jxr_linenumber" name="L237" href="#L237">237</a> <em class="jxr_javadoccomment">	 * Then try with PlatformUI.getWorkbench() ...</em>
<a class="jxr_linenumber" name="L238" href="#L238">238</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L239" href="#L239">239</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 	<strong class="jxr_keyword">protected</strong> ISelection getCurrentSelection() {
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 		ISelection selection=<strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 	
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 		<strong class="jxr_keyword">if</strong> (event != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 			<em class="jxr_comment">// Try to get selection from context</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 			Object context = event.getApplicationContext();
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 			<strong class="jxr_keyword">if</strong> ( context instanceof IEvaluationContext) {
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 				IEvaluationContext evaluationContext = (IEvaluationContext) context;
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 				selection = (ISelection)evaluationContext.getVariable(ISources.ACTIVE_CURRENT_SELECTION_NAME);
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 			}
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 		}
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 		<strong class="jxr_keyword">if</strong>( selection == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 			<em class="jxr_comment">// Try to get selection from ActivePage</em>
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 			IWorkbenchPage page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 			selection = page.getSelection();
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 		}
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 		<strong class="jxr_keyword">return</strong> selection;
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 	}
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L260" href="#L260">260</a> <em class="jxr_javadoccomment">	 * Get the uml resource used by the model.</em>
<a class="jxr_linenumber" name="L261" href="#L261">261</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L262" href="#L262">262</a> <em class="jxr_javadoccomment">	 * @return the Uml Resource</em>
<a class="jxr_linenumber" name="L263" href="#L263">263</a> <em class="jxr_javadoccomment">	 * @throws ServiceException </em>
<a class="jxr_linenumber" name="L264" href="#L264">264</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 	<strong class="jxr_keyword">protected</strong> UmlModel getUmlModel() <strong class="jxr_keyword">throws</strong> ServiceException {
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 		checkServiceRegistry();
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 		UmlModel umlModel = (UmlModel)ServiceUtils.getInstance().getModelSet(registry).getModel(UmlModel.MODEL_ID);
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 		<strong class="jxr_keyword">return</strong> umlModel;
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 	}
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L272" href="#L272">272</a> <em class="jxr_javadoccomment">	 * Gets the {@link IEditorPart} of the currently nested active editor.</em>
<a class="jxr_linenumber" name="L273" href="#L273">273</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L274" href="#L274">274</a> <em class="jxr_javadoccomment">	 * @param from</em>
<a class="jxr_linenumber" name="L275" href="#L275">275</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L276" href="#L276">276</a> <em class="jxr_javadoccomment">	 * @throws ServiceException</em>
<a class="jxr_linenumber" name="L277" href="#L277">277</a> <em class="jxr_javadoccomment">	 *             If an error occurs while getting the requested service.</em>
<a class="jxr_linenumber" name="L278" href="#L278">278</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 	<strong class="jxr_keyword">protected</strong> IEditorPart getNestedActiveIEditorPart() <strong class="jxr_keyword">throws</strong> ServiceException {
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 		checkServiceRegistry();
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 		<strong class="jxr_keyword">return</strong> ServiceUtils.getInstance().getService(ISashWindowsContainer.<strong class="jxr_keyword">class</strong>, registry).getActiveEditor();
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 	}
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L285" href="#L285">285</a> <em class="jxr_javadoccomment">	 * Get the main editing domain.</em>
<a class="jxr_linenumber" name="L286" href="#L286">286</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L287" href="#L287">287</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L288" href="#L288">288</a> <em class="jxr_javadoccomment">	 * @throws ServiceException</em>
<a class="jxr_linenumber" name="L289" href="#L289">289</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 	<strong class="jxr_keyword">protected</strong> TransactionalEditingDomain getEditingDomain() <strong class="jxr_keyword">throws</strong> ServiceException {
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 		checkServiceRegistry();
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 		<strong class="jxr_keyword">return</strong> ServiceUtils.getInstance().getTransactionalEditingDomain(registry);
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 	}
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L296" href="#L296">296</a> <em class="jxr_javadoccomment">	 * Obtains the service registry determined automatically from the context of which</em>
<a class="jxr_linenumber" name="L297" href="#L297">297</a> <em class="jxr_javadoccomment">	 * Papyrus editor or view is active (implying the model that the user is currently editing).</em>
<a class="jxr_linenumber" name="L298" href="#L298">298</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> <em class="jxr_javadoccomment">	 * @return the contextual service registry, or {@code null} if none can be determined</em>
<a class="jxr_linenumber" name="L300" href="#L300">300</a> <em class="jxr_javadoccomment">	 * @throws ServiceException </em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> <em class="jxr_javadoccomment">	 * @since 2.0</em>
<a class="jxr_linenumber" name="L302" href="#L302">302</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 	<strong class="jxr_keyword">protected</strong> ServicesRegistry getContextualServiceRegistry() <strong class="jxr_keyword">throws</strong> ServiceException {
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 		IContextualServiceRegistryTracker tracker = Activator.getDefault().getContextualServiceRegistryTracker();
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 		<strong class="jxr_keyword">if</strong>( tracker !=<strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 			<strong class="jxr_keyword">return</strong> tracker.getServiceRegistry();
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 		}
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 		<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> ServiceException(<span class="jxr_string">"Can't get ServiceRegistry from Tracker"</span>);
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 	}
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L312" href="#L312">312</a> <em class="jxr_javadoccomment">	 * Check if the {@link #registry} is set.</em>
<a class="jxr_linenumber" name="L313" href="#L313">313</a> <em class="jxr_javadoccomment">	 * Throw an exception if the {@link ServicesRegistry} property is not set.</em>
<a class="jxr_linenumber" name="L314" href="#L314">314</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L315" href="#L315">315</a> <em class="jxr_javadoccomment">	 * @throws ServiceException</em>
<a class="jxr_linenumber" name="L316" href="#L316">316</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> checkServiceRegistry() <strong class="jxr_keyword">throws</strong> ServiceException {
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 		<strong class="jxr_keyword">if</strong>(registry == <strong class="jxr_keyword">null</strong> ) {
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> ServiceException(<span class="jxr_string">"ServiceRegistry must be set prior using this method."</span>);
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 		}
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 	}
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 	
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L324" href="#L324">324</a> <em class="jxr_javadoccomment">	 * An internal {@link Job} implementation used to execute a part of the Handler as a Job.</em>
<a class="jxr_linenumber" name="L325" href="#L325">325</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L326" href="#L326">326</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/AbstractExecuteInJobHandler.html">JobForHandler</a> <strong class="jxr_keyword">extends</strong> Job {
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 		<strong class="jxr_keyword">private</strong> TransactionalEditingDomain domain;
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 		
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 		<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L332" href="#L332">332</a> <em class="jxr_javadoccomment">		 * Constructor.</em>
<a class="jxr_linenumber" name="L333" href="#L333">333</a> <em class="jxr_javadoccomment">		 * @param name </em>
<a class="jxr_linenumber" name="L334" href="#L334">334</a> <em class="jxr_javadoccomment">		 *</em>
<a class="jxr_linenumber" name="L335" href="#L335">335</a> <em class="jxr_javadoccomment">		 * @param domain</em>
<a class="jxr_linenumber" name="L336" href="#L336">336</a> <em class="jxr_javadoccomment">		 */</em>
<a class="jxr_linenumber" name="L337" href="#L337">337</a> 		<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/AbstractExecuteInJobHandler.html">JobForHandler</a>(String name, TransactionalEditingDomain domain) {
<a class="jxr_linenumber" name="L338" href="#L338">338</a> 			<strong class="jxr_keyword">super</strong>(name);
<a class="jxr_linenumber" name="L339" href="#L339">339</a> 			<strong class="jxr_keyword">this</strong>.domain = domain;
<a class="jxr_linenumber" name="L340" href="#L340">340</a> 		}
<a class="jxr_linenumber" name="L341" href="#L341">341</a> 
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 		@Override
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 		<strong class="jxr_keyword">protected</strong> IStatus run(IProgressMonitor monitor) {
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 			
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 			
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 				RecordingCommandForHandler command = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/AbstractExecuteInJobHandler.html">RecordingCommandForHandler</a>(domain, monitor);
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 				domain.getCommandStack().execute(command);
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 			} <strong class="jxr_keyword">catch</strong> (Exception e) {
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> Status(IStatus.ERROR, EDITOR_ID, e.getMessage(), e);
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 			}
<a class="jxr_linenumber" name="L352" href="#L352">352</a> 			
<a class="jxr_linenumber" name="L353" href="#L353">353</a> 			<strong class="jxr_keyword">return</strong> Status.OK_STATUS;
<a class="jxr_linenumber" name="L354" href="#L354">354</a> 		}
<a class="jxr_linenumber" name="L355" href="#L355">355</a> 
<a class="jxr_linenumber" name="L356" href="#L356">356</a> 		
<a class="jxr_linenumber" name="L357" href="#L357">357</a> 		
<a class="jxr_linenumber" name="L358" href="#L358">358</a> 	}
<a class="jxr_linenumber" name="L359" href="#L359">359</a> 	
<a class="jxr_linenumber" name="L360" href="#L360">360</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L361" href="#L361">361</a> <em class="jxr_javadoccomment">	 * An internal Recording command used to execute a part of the Handler in a Recording Transaction.</em>
<a class="jxr_linenumber" name="L362" href="#L362">362</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L363" href="#L363">363</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">class</strong>  RecordingCommandForHandler <strong class="jxr_keyword">extends</strong> RecordingCommand {
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 		<strong class="jxr_keyword">protected</strong> IProgressMonitor monitor=<strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 		
<a class="jxr_linenumber" name="L367" href="#L367">367</a> 		<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L368" href="#L368">368</a> <em class="jxr_javadoccomment">		 * Constructor.</em>
<a class="jxr_linenumber" name="L369" href="#L369">369</a> <em class="jxr_javadoccomment">		 *</em>
<a class="jxr_linenumber" name="L370" href="#L370">370</a> <em class="jxr_javadoccomment">		 * @param domain</em>
<a class="jxr_linenumber" name="L371" href="#L371">371</a> <em class="jxr_javadoccomment">		 * @param domain2</em>
<a class="jxr_linenumber" name="L372" href="#L372">372</a> <em class="jxr_javadoccomment">		 * @param monitor</em>
<a class="jxr_linenumber" name="L373" href="#L373">373</a> <em class="jxr_javadoccomment">		 */</em>
<a class="jxr_linenumber" name="L374" href="#L374">374</a> 		<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/AbstractExecuteInJobHandler.html">RecordingCommandForHandler</a>(TransactionalEditingDomain domain, IProgressMonitor monitor) {
<a class="jxr_linenumber" name="L375" href="#L375">375</a> 			<strong class="jxr_keyword">super</strong>(domain);
<a class="jxr_linenumber" name="L376" href="#L376">376</a> 			<strong class="jxr_keyword">this</strong>.monitor = monitor;
<a class="jxr_linenumber" name="L377" href="#L377">377</a> 		}
<a class="jxr_linenumber" name="L378" href="#L378">378</a> 
<a class="jxr_linenumber" name="L379" href="#L379">379</a> 		<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L380" href="#L380">380</a> <em class="jxr_javadoccomment">		 * @see org.eclipse.emf.transaction.RecordingCommand#doExecute()</em>
<a class="jxr_linenumber" name="L381" href="#L381">381</a> <em class="jxr_javadoccomment">		 *</em>
<a class="jxr_linenumber" name="L382" href="#L382">382</a> <em class="jxr_javadoccomment">		 */</em>
<a class="jxr_linenumber" name="L383" href="#L383">383</a> 		@Override
<a class="jxr_linenumber" name="L384" href="#L384">384</a> 		<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> doExecute() {
<a class="jxr_linenumber" name="L385" href="#L385">385</a> 			<em class="jxr_comment">// Call the appropriate method in the parent class</em>
<a class="jxr_linenumber" name="L386" href="#L386">386</a> 			doExecuteTransactionInJob( monitor );
<a class="jxr_linenumber" name="L387" href="#L387">387</a> 		}
<a class="jxr_linenumber" name="L388" href="#L388">388</a> 		
<a class="jxr_linenumber" name="L389" href="#L389">389</a> 		
<a class="jxr_linenumber" name="L390" href="#L390">390</a> 	}
<a class="jxr_linenumber" name="L391" href="#L391">391</a> 
<a class="jxr_linenumber" name="L392" href="#L392">392</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
